//---------------------------------------------------------------------------


#pragma hdrstop

#include "SharedData.h"
#include "resource.h"
#include "Unit6.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma classgroup "Vcl.Controls.TControl"
#pragma resource "*.dfm"
TSharedDataModule *SharedDataModule;
//---------------------------------------------------------------------------
__fastcall TSharedDataModule::TSharedDataModule(TComponent* Owner)
	: TDataModule(Owner)
{
}

//---------------------------------------------------------------------------
// C++Builder doesn't support .ico for adding to collection so doing it manually
void __fastcall TSharedDataModule::LoadIconsToImageCollection(TImageCollection *imagecollection, UINT idistart, UINT idiend)
{
	// initialize objects to create
	TIcon *icon=NULL;
	TBitmap *bitmap=NULL;

	__try {
		try {
			// create objects needed
			static const int imgformats[]={16,24,32,48};//,64};
			icon=new TIcon;
			bitmap=new TBitmap;

			for (UINT i=idistart; i<=idiend; i++) {
				// add new image index item
				TImageCollectionItem *collectionitem=imagecollection->Images->Add();

				for (int iif=0; iif<ARRAYSIZE(imgformats);iif++) {
					// load our icon of the correct size
					icon->Handle=reinterpret_cast<HICON>(LoadImage(HInstance, MAKEINTRESOURCE(i), IMAGE_ICON, imgformats[iif], imgformats[iif], 0));
					// convert to bitmap
					bitmap->Assign(icon);
					// add a new image for the image format
					TImageCollectionSourceItem *imageitem=collectionitem->SourceImages->Add();
					// copy bitmap over as the new image format
					imageitem->Image->Assign(bitmap);
				}
			}
		}
		catch(Exception &E) {

		}
	}
	__finally {
		// clean up as needed
		delete bitmap;
		delete icon;
	}
}

//---------------------------------------------------------------------------

void __fastcall TSharedDataModule::DataModuleCreate(TObject *Sender)
{
	// load icons
	LoadIconsToImageCollection(ImageCollection, IDI_USER_ICON_START, IDI_USER_ICON_END);

	// fill image lists
	Form6->VirtualImageList16->AutoFill=true;
}
//---------------------------------------------------------------------------
